/**
 *
 */
package org.n52.sos.web;

import org.apache.commons.io.IOUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.n52.sos.response.GetCapabilitiesResponse;
import org.n52.sos.web.auth.CustomPrincipal;
import org.n52.sos.web.model.dto.*;
import org.n52.sos.web.model.services.ApiKeyService;
import org.n52.sos.web.model.services.RestriccionService;
import org.n52.sos.web.model.services.UserService;
import org.n52.sos.web.model.services.UtilsService;
import org.n52.sos.web.model.vo.ApiKeyVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.io.*;
import java.lang.invoke.MethodHandles;
import java.sql.SQLException;
import java.util.List;
import java.util.Map;

/**
 * @since 4.0.0
 *
 */
@Controller
public class VisorController extends AbstractController {

    private static final Logger LOGGER = LogManager.getLogger(MethodHandles.lookup().lookupClass());

    @Autowired
    private UserService userService;
    @Autowired
    private UtilsService utilsService;
    @Autowired
    private ApiKeyService apiKeyService;
    @Autowired
    private RestriccionService restriccionService;

    @RequestMapping(value = "/visor", method = RequestMethod.GET)
    public ModelAndView visor() {

        Authentication auth = SecurityContextHolder.getContext().getAuthentication();

        ModelAndView modelAndView = new ModelAndView("visor");

        String apiKey = null;
        // Get apikey of admin to set it o apikey

        try {
            if (auth.getPrincipal() instanceof String) {
                LOGGER.info("\n\n\n\n\n AUTH-PRINCIPALS INSTANCE OF STRING\n\n\n\n\n");
                apiKey = userService.getAnonymousApiKey();
            } else {
                LOGGER.info("\n\n\n\n\n AUTH-PRINCIPALS not not not not INSTANCE OF STRING\n\n\n\n\n");
                apiKey = ((CustomPrincipal)auth.getPrincipal()).getApikey();
            }

        } catch (Exception e) {
            LOGGER.info("\n\n\n\n\n EXCEPTION \n\n\n\n\n");
            apiKey = userService.getAnonymousApiKey();
        }

        modelAndView.addObject("apikey", apiKey);

    	return modelAndView;
    }

    @RequestMapping(value = "/visor/content", method = RequestMethod.GET)
    public ModelAndView visorContent() {

        Authentication auth = SecurityContextHolder.getContext().getAuthentication();

        ModelAndView modelAndView = new ModelAndView("visor/index");

        String apiKey = null;
        // Get apikey of admin to set it o apikey
        if (auth != null && auth.getPrincipal() != null) {
            apiKey = userService.getAnonymousApiKey();
        } else {
            apiKey = ((CustomPrincipal)auth.getPrincipal()).getApikey();
        }

        modelAndView.addObject("apikey", apiKey);

        return modelAndView;
    }

    @RequestMapping(value = "/visor/capabilities", method = RequestMethod.GET)
    public ResponseEntity<byte[]> getCapabilitiesFile() {
        LOGGER.info("\n\n\ngetCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()");
        LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()			1");
        LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()\n\n\n");

        String path = System.getProperty("apps_data_path") + File.separator + "metsos" + File.separator + "getCapabilities.txt";
        File f = new File(path);

        try( InputStream in = new FileInputStream(f)) {
            HttpHeaders headers = new HttpHeaders();

            LOGGER.info("\n\n\ngetCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()");
            LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()			2");
            LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()\n\n\n");


            return new ResponseEntity<byte[]>(IOUtils.toByteArray(in),headers, HttpStatus.OK);
        } catch (IOException ex) {
            LOGGER.info(ex.getMessage());
            LOGGER.info("\n\n\ngetCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()");
            LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()			3");
            LOGGER.info("getCapabilitiesFile()getCapabilitiesFile()getCapabilitiesFile()\n\n\n");
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }
    }


    @RequestMapping(value = "/sos-service/updateCapabilities", method = RequestMethod.POST)
    public ResponseEntity<GetCapabilitiesResponse> updateCapabilities(
            @RequestBody UpdateCapabilitiesObject capabilities){

        LOGGER.info("\n\n\n\n");
        LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        1");
        LOGGER.info("\n\n\n\n");

        //String path = System.getProperty("apps_data_path") + File.separator + "metsos" + File.separator + "getCapabilities.txt";
        String path = System.getProperty("apps_data_path") + File.separator + "metsos" + File.separator + "getCapabilities.txt";
        File f = new File(path);
        if (f != null) {

            LOGGER.info("\n\n\n\n");
            LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        2.1.1");
            LOGGER.info("\n\n\n\n");

            f.delete();
        } else {

            LOGGER.info("\n\n\n\n");
            LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        2.2.1");
            LOGGER.info("\n\n\n\n");

            try {
                f.createNewFile();
                LOGGER.info("\n\n\n\n");
                LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        2.2.2");
                LOGGER.info("\n\n\n\n");
            } catch (IOException e) {
                LOGGER.info("\n\n\n\n");
                LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        2.2.3");
                LOGGER.info("\n\n\n\n");
                LOGGER.catching(e);

                return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
            }
        }

        LOGGER.info("\n\n\n\n");
        LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        3");
        LOGGER.info("\n\n\n\n");

        try (PrintWriter out = new PrintWriter(f)) {

            LOGGER.info("\n\n\n\n");
            LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        4");
            LOGGER.info("\n\n\n\n");

            out.print(capabilities.getCapabilities());
            out.close();

            LOGGER.info("\n\n\n\n");
            LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        5");
            LOGGER.info("\n\n\n\n");

            return new ResponseEntity<>(HttpStatus.OK);
        } catch (FileNotFoundException e) {
            LOGGER.info("\n\n\n\n");
            LOGGER.info("updateCapabilities-updateCapabilities-updateCapabilities        6");
            LOGGER.info("\n\n\n\n");
            LOGGER.catching(e);
            return new ResponseEntity<>(HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }


    @RequestMapping(value = "/visor-services/meteodatos/intervalos/config", method = RequestMethod.GET)
    public ResponseEntity<Map<String, IntervaloConfigElementDTO>> getMeteodatosIntervalosConfig(HttpServletRequest request) {

        String apikey = request.getHeader("apikey");

        // Retrieve anonymous user's apikey from database
        String apiKekAnonymousUser = userService.getAnonymousApiKey();
        if (apiKekAnonymousUser==null || apiKekAnonymousUser.isEmpty() || !apiKekAnonymousUser.equals(apikey)) {
            return new ResponseEntity<>(HttpStatus.METHOD_NOT_ALLOWED);
        }
        return new ResponseEntity<>(utilsService.recuperarConfiguracionIntervalosMeteodatos(), HttpStatus.OK);
    }

    @RequestMapping(value = "/visor-services/plataformas/intervalos/config", method = RequestMethod.GET)
    public ResponseEntity<Map<String, IntervaloConfigElementDTO>> getPlataformasIntervalosConfig(HttpServletRequest request) {

        String apikey = request.getHeader("apikey");

        // Retrieve user's apikey from database
        String apiKekAnonymousUser = userService.getAnonymousApiKey();
        if (apiKekAnonymousUser==null || apiKekAnonymousUser.isEmpty() || !apiKekAnonymousUser.equals(apikey)) {
            return new ResponseEntity<>(HttpStatus.METHOD_NOT_ALLOWED);
        }
        return new ResponseEntity<>(utilsService.recuperarConfiguracionIntervalosPlataformas(), HttpStatus.OK);
    }

    @RequestMapping(value = "/visor-services/meteodatos/funciones", method = RequestMethod.GET)
    public ResponseEntity<List<FuncionMeteoDatosDTO>> getMeteodatosFunciones(HttpServletRequest request) {

        String apikey = request.getHeader("apikey");

        // Retrieve user's apikey from database
        String apiKekAnonymousUser = userService.getAnonymousApiKey();
        if (apiKekAnonymousUser==null || apiKekAnonymousUser.isEmpty() || !apiKekAnonymousUser.equals(apikey)) {
            return new ResponseEntity<>(HttpStatus.METHOD_NOT_ALLOWED);
        }
        return new ResponseEntity<>(utilsService.recuperarFuncionesMeteodatos(), HttpStatus.OK);
    }

    @RequestMapping(value = "/visor-services/restricciones", method = RequestMethod.GET)
    public ResponseEntity<List<RestriccionDTO>> getRestricciones(HttpServletRequest request) {

        String apikey = request.getHeader("apikey");

        // Retrieve user's apikey from database
        String apiKekAnonymousUser = userService.getAnonymousApiKey();
        if (apiKekAnonymousUser==null || apiKekAnonymousUser.isEmpty() || !apiKekAnonymousUser.equals(apikey)) {
            return new ResponseEntity<>(HttpStatus.METHOD_NOT_ALLOWED);
        }
        return new ResponseEntity<>(restriccionService.recuperarTodasLasRestricciones(), HttpStatus.OK);
    }

}